using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls;
using Telerik.WinControls.RadControlSpy;

namespace RadPanelBarGroupEdit
{
    public partial class Form1 : Form
    {
        RadElement clickedElement;
        RadPanelBarGroupElement groupElement;
        RadPanelBarVisualElement captionElement;
        RadTextBoxElement textBox;

        public Form1()
        {
            InitializeComponent();

            new RadControlSpyForm().Show();

            this.radPanelBar1.MouseDown += new MouseEventHandler(radPanelBar1_MouseDown);
            this.radPanelBar1.Items.ItemsChanged += new ItemChangedDelegate(Items_ItemsChanged);
        }

        void Items_ItemsChanged(RadItemCollection changed, RadItem target, ItemsChangeOperation operation)
        {
            RemoveExistingRadTextBoxes();

            groupElement = target as RadPanelBarGroupElement;
            if (groupElement != null)
            {
                AddRadTextBoxElement();
            }
        }

        void radPanelBar1_MouseDown(object sender, MouseEventArgs e)
        {
            RemoveExistingRadTextBoxes();

            if (e.Button == MouseButtons.Right)
            {
                Point location = new Point(e.X, e.Y);
                clickedElement = this.radPanelBar1.ElementTree.GetElementAtPoint(location) as RadElement;
                if((clickedElement != null) && (clickedElement is RadPanelBarVisualElement))
                {
                    groupElement = clickedElement.Parent.Parent.Parent.Parent as RadPanelBarGroupElement;
                    if (groupElement != null)
                    {
                        if (groupElement.Expanded)
                        {
                            groupElement.Expanded = false;
                        }
                        else
                        {
                            groupElement.Expanded = true;
                        }

                        AddRadTextBoxElement();
                    }
                }
            }
        }

        void tbel_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                groupElement.Caption = textBox.Text;
                for (int i = 0; i < captionElement.Children.Count;i++ )
                {
                    if (captionElement.Children[i] is RadTextBoxElement)
                    {
                        captionElement.Children.RemoveAt(i);
                    }
                }
            }
        }

        private void radButton2_Click(object sender, EventArgs e)
        {
            RadPanelBarGroupElement addedElement = new RadPanelBarGroupElement();
            addedElement.Caption = "New Element";
            this.radPanelBar1.Items.Add(addedElement);
        }

        private void RemoveExistingRadTextBoxes()
        {
            for (int j = 0; j < this.radPanelBar1.Items.Count; j++)
            {
                RadPanelBarGroupElement group = this.radPanelBar1.Items[j] as RadPanelBarGroupElement;
                if (group != null)
                {
                    RadPanelBarVisualElement caption = group.GetCaptionElement();
                    {
                        for (int i = 0; i < caption.Children.Count; i++)
                        {
                            if (caption.Children[i] is RadTextBoxElement)
                            {
                                caption.Children.RemoveAt(i);
                            }
                        }
                    }
                }
            }
        }


        private void AddRadTextBoxElement()
        {
            textBox = new RadTextBoxElement();
            captionElement = groupElement.GetCaptionElement();
            captionElement.Children.Add(textBox);
            textBox.TextBoxItem.Focus();
            textBox.KeyDown += new KeyEventHandler(tbel_KeyDown);
        }
    }
}